/*
 * inode.c             Copyright (C) 2004-2009 Dmitry Yakovlev
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 */
                                                                         
#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include "qnx4fs_fs.h"
/*                                                              
static int qnx4fs_count_iblocks (struct inode *ip)
{
	struct buffer_head *bp;
	qnx4fs_xb_t *xb;
	unsigned long iblocks, xbnr;

	iblocks = (ip->i_size + QNX4FS_BLOCK_SIZE-1) >> QNX4FS_BLOCK_SIZE_BITS;

	xbnr = QNX4FS_I(ip)->i_xbnr0;
	while (xbnr) {
		bp = sb_bread(ip->i_sb, xbnr - 1);
		if (bp == NULL)
			return -1;
		xb = (qnx4fs_xb_t *)bp->b_data;
		if (memcmp(xb->xb_signature, "IamXblk\0", 8)) {
			brelse(bp);
			fprintf(stderr," Wrong xblk signature\n");
			return -1;
		}
		++iblocks;
		QNX4FS_I(ip)->i_xbnr_last = xbnr;
		xbnr = le32_to_cpu(xb->xb_next);
		brelse(bp);
	}
	ip->i_blocks = iblocks;
	return 0;
}
*/
int qnx4fs_print_inode (struct inode *ip)
{
	struct buffer_head *bp;
	qnx4fs_dinode_t *qip;

	bp = sb_bread(ip->i_sb, ino2phys(ip->i_ino));
	if (bp == NULL)
		return -1;
	qip = (qnx4fs_dinode_t *)bp->b_data + ino2slot(ip->i_ino);
	
		QNX4FS_PRINT(
		"    inode stat  size      xblk     xtnt0 xtnt0sze xtnts nlink mode\n"
		"%9u %02X %7u %9u %9u %7u %5u %5u %4x\n",
		(unsigned)ip->i_ino,
		(unsigned)qip->i.status,
		(unsigned)le32_to_cpu(qip->i.size),
		(unsigned)le32_to_cpu(qip->i.xb),
		(unsigned)le32_to_cpu(qip->i.xt0.start),
		(unsigned)le32_to_cpu(qip->i.xt0.size),
		(unsigned)le16_to_cpu(qip->i.nxt),
		(unsigned)le16_to_cpu(qip->i.nlink),
		(unsigned)le16_to_cpu(qip->i.mode)
	);

	brelse(bp);
	return 0;
}

int qnx4fs_read_inode (struct inode *ip)
{
	struct buffer_head *bp;
	qnx4fs_dinode_t *qip;
	ino_t ino = ip->i_ino;

	bp = sb_bread(ip->i_sb, ino2phys(ino));

	if (bp == NULL)
		return -1;

	qip = (qnx4fs_dinode_t *)bp->b_data + ino2slot(ino);

	ip->i_mode	= le16_to_cpu(qip->i.mode);
	ip->i_size	= le32_to_cpu(qip->i.size);
        ip->i_nlink	= le16_to_cpu(qip->i.nlink);

	QNX4FS_I(ip)->i_status		= qip->i.status;

	QNX4FS_I(ip)->i_nxt		= le16_to_cpu(qip->i.nxt);
	QNX4FS_I(ip)->i_xbnr		= QNX4FS_I(ip)->i_xbnr0
					= le32_to_cpu(qip->i.xb);
	QNX4FS_I(ip)->i_phys		= QNX4FS_I(ip)->i_xt0.start
					= le32_to_cpu(qip->i.xt0.start);
	QNX4FS_I(ip)->i_offset_end	= QNX4FS_I(ip)->i_xt0.size
					= le32_to_cpu(qip->i.xt0.size);
	QNX4FS_I(ip)->i_offset		= 0;
	QNX4FS_I(ip)->i_xtnr		= -1;

	QNX4FS_I(ip)->i_linked		= qip->i.status & QNX4FS_FILE_INODE;

	brelse(bp);
	return 0;
}

