
static const char usage[] = "usage: ./bpatch file.bdiff file.img\n";

#include <stdio.h>

int main(int argc, char **argv)
{
	FILE *diff, *file;
	char patchline[50];
	unsigned long offset;
	unsigned byte1, byte2;
	
	if(argc != 3){
		fprintf(stderr, usage);
		return -1;
	}

	diff = fopen(argv[1], "r");
	if (diff == NULL) {
		fprintf(stderr, "error opening <%s>", argv[1]);
		perror("");
		return -1;
	}

	file = fopen(argv[2], "r+");
	if (file == NULL) {
		fprintf(stderr, "error opening <%s>", argv[2]);
		perror("");
		return -1;
	}
	
	while (fgets(patchline, sizeof(patchline), diff) != NULL) {
		if(sscanf(patchline, "%lu %u %u", &offset, &byte1, &byte2) != 3){ 
			perror("error parsing patchline");
			break;
		}
		if(fseek (file, offset, SEEK_SET) < 0) {
			perror("error setting position");
			break;
		}

		if(fgetc(file) == byte1) {
			if(fseek (file, offset, SEEK_SET) < 0){
				perror("error setting position");
				break;
			}
			
			if(fputc (byte2, file) == EOF){
				perror("error writing to file");
				break;
			}
			continue;
		}
		
		fprintf(stderr, "source byte isn't equal to byte from patchline %u: %u\n", byte1, byte2);
	}
	
	fclose (diff);
	fclose (file);
	   
	return 0;
}
