
static const char usage[] = "usage: ./bprand seed maxoffset count file\n";

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int main(int argc, char **argv)
{
	FILE *file;
	off_t offset, maxoffset;
	unsigned char byte1, byte2;
	int seed, count;
	
	if(argc != 5){
		fprintf(stderr, usage);
		return -1;
	}

	seed =      atoi(argv[1]);
	maxoffset = atoi(argv[2]);
	count =     atoi(argv[3]);

	if((file = fopen(argv[4], "r+")) == NULL) {
		fprintf(stderr, "error opening <%s> ", argv[4]);
		perror("");
		return -1;
	}

	srand(seed);
	while(count-- > 0) {
		offset = (off_t)(((double)rand() * maxoffset)/(RAND_MAX + 1.0));
		byte2 = rand() ^ offset;

		if(fseek (file, offset, SEEK_SET) < 0) {
			perror("error setting position");
			perror("");
			return 1;
		}

		byte1 = fgetc(file);

		if(fseek (file, offset, SEEK_SET) < 0){
			perror("error setting position");
			return 1;
		}
			
		if(fputc (byte2, file) == EOF){
			perror("error writing to file");
			return 1;
		}
		printf(" %7lu %3u %3u\n", (unsigned long)offset, (unsigned)byte1, (unsigned)byte2);
	}
	              	
	fclose (file);
	return 0;
}
