
static const char usage[] = "usage: ./bincmp srcfile patchedfile\n";

#include <stdio.h>

#define BUFSZE 10000

int main(int argc, char **argv){
	int i, sze;
	static unsigned char buffer1[BUFSZE], buffer2[BUFSZE];
	unsigned long  part;
	FILE *file1, *file2;

	if(argc != 3){
		fprintf(stderr, usage);
		return -1;
	}

	file1 = fopen(argv[1], "r");
	if (file1 == NULL) {
		fprintf(stderr, "error opening %s", argv[1]);
		perror("");
		return -1;
	}

	file2 = fopen(argv[2], "r");
	if (file2 == NULL) {
		fprintf(stderr, "error opening %s", argv[2]);
		perror("");
		return -1;
	}

	for (part = 0; ((sze = fread(buffer1, 1, BUFSZE, file1)) != 0)
	&& (sze == fread(buffer2, 1, BUFSZE, file2)); part++) {
		for(i = 0; i < sze; i++) {
			if (buffer1[i] != buffer2[i]) 
				printf("%lu %u %u\n", part * BUFSZE + i, buffer1[i], buffer2[i]);
		}
	}

	fclose (file1);
	fclose (file2);
	
	return 0;
}
